program DrvLoad;

uses
  Forms,
  SysUtils,
  DrvLoad_u1 in 'DrvLoad_u1.pas' {Form1},
  driver in 'driver.pas';

{$R *.RES}
const
      ACTION_INSTALL     =  1;
      ACTION_START       =  2;
      ACTION_STOP        =  4;
      ACTION_UNINSTALL   =  8;
      ACTION_RUN         =  ACTION_INSTALL + ACTION_START;
      ACTION_REMOVE      =  ACTION_STOP + ACTION_UNINSTALL;
      ACTION_MAXVALUE    = 16;

var RunGUI:boolean;
    l,DoAction:integer;
    param,DriverExec,DriverName:string;

begin
  DoAction:=0;
  RunGui:=(ParamCount=0);
  DriverExec:='';
  DriverName:='';
  if not RunGUI then
    begin
     for l:=1 to ParamCount do
      begin
       param:=ParamStr(l);
       if LowerCase(param)='/start' then DoAction:=ACTION_START else
       if LowerCase(param)='/stop' then DoAction:=ACTION_STOP else
       if LowerCase(param)='/install' then DoAction:=ACTION_INSTALL else
       if LowerCase(param)='/uninstall' then DoAction:=ACTION_UNINSTALL else
       if LowerCase(param)='/run' then DoAction:=ACTION_RUN else
       if LowerCase(param)='/remove' then DoAction:=ACTION_REMOVE else
       if LowerCase(param)='/gui' then RunGUI:=true else
       if LowerCase(param)='/quiet' then ShowErrorBoxes:=false else
       if Pos('/d:',LowerCase(param))<>0 then
         DriverExec:=copy(param,4,length(param)) else
       if Pos('/n:',LowerCase(param))<>0 then
         DriverName:=copy(param,4,length(param));
      end; //for
     case DoAction of
        ACTION_INSTALL   : InstallDriver(DriverName,DriverExec);
        ACTION_START     : StartDriver(DriverName);
        ACTION_STOP      : StopDriver(DriverName);
        ACTION_UNINSTALL : RemoveDriver(DriverName);
        ACTION_RUN       : begin
                            InstallDriver(DriverName,DriverExec);
                            StartDriver(DriverName);
                           end;
        ACTION_REMOVE    : begin
                            StopDriver(DriverName);
                            RemoveDriver(DriverName);
                           end;
      end; //case
    end; // if
  if RunGUI then
    begin
      Application.Initialize;
      Application.CreateForm(TForm1, Form1);
      Form1.FilenameEdit1.Filename:=DriverExec;
      Form1.EdtName.Text:=DriverName;
      ShowErrorBoxes:=true;
      Application.Run;
    end;
end.
