unit DrvLoad_u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    FilenameEdit1: TFilenameEdit;
    BtnExit: TButton;
    LblDriver: TLabel;
    BtnInstall: TButton;
    BtnUninstall: TButton;
    BtnStart: TButton;
    BtnStop: TButton;
    EdtName: TEdit;
    Label1: TLabel;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure BtnExitClick(Sender: TObject);
    procedure BtnInstallClick(Sender: TObject);
    procedure BtnStartClick(Sender: TObject);
    procedure BtnStopClick(Sender: TObject);
    procedure BtnUninstallClick(Sender: TObject);
    procedure FilenameEdit1AfterDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure EdtNameChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses driver,services;

{$R *.DFM}

procedure TForm1.BtnExitClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.BtnInstallClick(Sender: TObject);
begin
 if FileExists(FilenameEdit1.FileName) then
   begin
    InstallDriver(EdtName.Text,FilenameEdit1.FileName);
   end else ShowMessage('Driver '+FilenameEdit1.FileName+' not found !');
end;

procedure TForm1.BtnStartClick(Sender: TObject);
begin
 StartDriver(EdtName.Text);
end;

procedure TForm1.BtnStopClick(Sender: TObject);
begin
 StopDriver(EdtName.Text);
end;

procedure TForm1.BtnUninstallClick(Sender: TObject);
begin
 if GetDriverStatus(EdtName.Text)=SERVICE_RUNNING then
    StopDriver(EdtName.Text);
 RemoveDriver(EdtName.Text);
end;

procedure TForm1.FilenameEdit1AfterDialog(Sender: TObject;
  var Name: String; var Action: Boolean);
var s:string;
begin
  s:=ExtractFileName(Name);
  s:=copy(s,1,Pos('.',s)-1);
  EdtName.Text:=UpperCase(s);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 StatusBar1.Panels[0].Text:='written by Guido Wischrop';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Status:integer;
begin
if EdtName.text<>'' then
 begin
   Status:=GetDriverStatus(EdtName.Text);
   case Status of
    SERVICE_STOPPED           : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - stopped';
                                end;
    SERVICE_START_PENDING     : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - starting';
                                end;
    SERVICE_STOP_PENDING      : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - stopping';
                                end;
    SERVICE_RUNNING           : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - running';
                                end;
    SERVICE_CONTINUE_PENDING  : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - continued';
                                end;
    SERVICE_PAUSE_PENDING     : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - pausing';
                                end;
    SERVICE_PAUSED            : begin
                                 StatusBar1.Panels[1].Text:=EdtName.Text+
                                      ' - paused';
                                end;
      else StatusBar1.Panels[1].Text:=EdtName.Text+' - not installed';
    end; //case
  end; // if
end;

procedure TForm1.EdtNameChange(Sender: TObject);
var mConfig:PQueryServiceConfig;
begin
 mConfig:=GetDriverConfig(EdtName.Text);
 if mConfig.dwServiceType<>-1 then
  begin
   FilenameEdit1.Text:=copy(mConfig.lpBinaryPathName,Pos(':',
                                mConfig.lpBinaryPathName)-1,
                                length(mConfig.lpBinaryPathName));
  end;
 FreeMem(mConfig);
end;

end.
