//
// Hauptformular fr IDT Look
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, myRegistry, myVers,Menus;

type DevListEntry = packed record
            Name           : string[80];
            ResCount       : integer;
            ResList        : array [0..255] of TPartialResourceDescriptor;
          end;

type IntListEntry = packed record
            Count : integer;
            List  : array [0..127] of integer;
          end;

type idt_entry= packed record
        offs_0x15 : word;
        segm_sel  : word;
        reserved0 : byte;
        flags     : byte;
        offs_16x31: word;
      end;


type
  TForm1 = class(TForm)
    Memo1: TMemo;
    StringGrid1: TStringGrid;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveList1: TMenuItem;
    OpenList1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    View1: TMenuItem;
    Refresh1: TMenuItem;
    Info1: TMenuItem;
    About1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Help1: TMenuItem;
    N2: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveList1Click(Sender: TObject);
    procedure OpenList1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
  private
    myHandle:THandle;
    IntList: array [0..255] of IntListEntry;
    DevList: array [0..255] of DevListEntry;
    idt: array [0..$7FF] of idt_entry;
    ListLoaded:boolean;
    procedure ShowRessources(key:string);
    procedure GetResList(key,value:string;DevIndex:integer);
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

const IOCTL_IDTRead_GetIDT  = $222004;

const ReservedInterrupts: array [0..18] of string=(
        'Divide Error Exception (#DE)',
        'Debug Execption (#DB)',
        'NMI - non maskable interrupt',
        'Breakpoint Execption (#BP)',
        'Overflow Exception (#OF)',
        'Bound Range Exceed Exception (#BR)',
        'Invalid Opcode Exception (#UD)',
        'Device Not Available Exception (#NM)',
        'Double Fault Exception (#DF)',
        'Coprozessor Segment Overrun',
        'Invalid TSS Exception (#TS)',
        'Segment Not Present (#NP)',
        'Stack Fault Exception (#SS)',
        'General Protection Exception (#GP)',
        'Page Fault Exception (#PF)',
        '(reserved)',
        'Floating Point Error Exception (#MF)',
        'Alignment Check Exception (#AC)',
        'Machine-Check Exception (#MC)');

implementation

uses driver_u1, Unit2, resviewpas;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);

const   SegmentPresent = $80;
        TaskGate       = $05;
        InterruptGate  = $06;
        TrapGate       = $07;
        GateSize       = $08;
        DPL            = $60;

var i,j,mDPL:integer;
    rb:cardinal;
    mCS,mES,mDS:word;
    s,s1:string;
    b:boolean;

begin
StringGrid1.Cells[1,0]:='Segm.Descriptor';
StringGrid1.Cells[2,0]:='Offset';
StringGrid1.Cells[3,0]:='GateSize/DPL';
StringGrid1.Cells[4,0]:='GateType';
StringGrid1.Cells[5,0]:='Device';
if ListLoaded then
  begin
   Memo1.Lines.Add('using IDT from file ...');
   b:=true;
   rb:=256 shl 3;
  end else
  begin
   Memo1.Lines.Add('reading IDT from driver ...');
   b:=DeviceIoControl(myHandle,IOCTL_IDTRead_GetIDT,NIL,0,
                   @idt,sizeof(idt),rb,NIL);
  end;
if b then
  begin
    asm
      mov      ax,cs
      mov      mCS,ax
      mov      ax,ds
      mov      mDS,ax
      mov      ax,es
      mov      mES,ax
    end;
    Memo1.Lines.Add(IntToStr(rb shr 3)+' entrys in IDT - '+
                  '(CS:0x'+IntToHex(mCS,5)+') (DS:0x'+IntToHex(mDS,5)+')');
    for i:=0 to (rb shr 3)-1 do
      begin
        j:=integer((idt[i].offs_16x31 shl 16)) + integer(idt[i].offs_0x15);
        if (idt[i].flags and SegmentPresent)<>0 then
             s:='Interrupt '+IntToHex(i,2)+':  '+IntToHex(idt[i].segm_sel,5)+
                ':'+IntToHex(j,9) else
             s:='Interrupt '+IntToHex(i,2)+': x'+IntToHex(idt[i].segm_sel,5)+
                IntToHex(j,9);
        if (idt[i].flags and GateSize)<>0 then
             s1:=' 32 bit' else
             s1:=' 16 Bit';
        s:=s+s1;
        mDPL:=(idt[i].flags and DPL) shr 5;
        StringGrid1.Cells[3,i+1]:=s1+' / DPL='+IntToStr(mDPL);
        if (idt[i].flags and $07)=TaskGate then
             s1:=' TaskGate' else
          if (idt[i].flags and $07)=InterruptGate then
             s1:=' InterruptGate' else
          if (idt[i].flags and $07)=TrapGate then
             s1:=' TrapGate' else
             s1:=' Unknown ';
        s:=s+s1;
        StringGrid1.Cells[4,i+1]:=s1;
        s:=s+' DPL='+IntToStr(mDPL)+' / ('+IntToStr(IntList[i].count)+')';
        s:=s+' '+IntToHex(idt[i].reserved0,3)+'/'+IntToStr(i);
//        Memo1.Lines.Add(s);
        StringGrid1.Cells[0,i+1]:='Interrupt '+IntToHex(i,2)+'/'+IntToStr(i);
        StringGrid1.Cells[1,i+1]:=IntToHex(idt[i].segm_sel,5);
        StringGrid1.Cells[2,i+1]:=IntToHex(j,9);
        if i<32 then
          StringGrid1.Cells[5,i+1]:='reserved' else
        if IntList[i].Count>0 then
          StringGrid1.Cells[5,i+1]:=DevList[IntList[i].List[0]].Name else
          StringGrid1.Cells[5,i+1]:='';
      end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var sa:PSecurityAttributes;
    l:integer;

begin
 if now>StrToDateTime('01.02.1999 0:00') then
   begin
     ShowMessage('This version is expired !'+#10#13+
                 'You might get a new version at http://www.wischrop-net.de/nt '#10#13#10#13+
                 'Sorry for making such a fuss ;-I ');
     halt(0);
   end;
 ListLoaded:=false;
 InstallDriver('IDTRead',ExtractFilePath(ParamStr(0))+'idt.sys');
 StartDriver('IDTRead');
 sa:=new(PSecurityAttributes);
 sa.nLength:=sizeof(TSecurityAttributes);
 sa.lpSecurityDescriptor:=NIL;
 sa.bInheritHandle:=false;
 myHandle:=CreateFile('\\.\IDTRead',GENERIC_READ,FILE_SHARE_READ,
                     sa,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 for l:=0 to 255 do IntList[l].Count:=0;
 Button3Click(Sender);
 Button1Click(Sender);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 CloseHandle(myHandle);
 StopDriver('IDTRead');
 RemoveDriver('IDTRead');
end;

procedure TForm1.Button2Click(Sender: TObject);
var AdapterList,AdapterEntrys:TStringList;
    l,l1:integer;

begin
AdapterList:=TStringList.Create;
ReadKeys(HKLM,'Hardware\Description\System\MultifunctionAdapter',
         AdapterList);
for l:=0 to AdapterList.Count-1 do
 begin
  ShowRessources('Hardware\Description\System\MultifunctionAdapter\'+
                 AdapterList.Strings[l]);
  AdapterEntrys:=TStringList.Create;
  ReadKeys(HKLM,'Hardware\Description\System\MultifunctionAdapter\'+
         AdapterList.Strings[l],AdapterEntrys);
  for l1:=0 to AdapterEntrys.Count-1 do
   begin
    ShowRessources('Hardware\Description\System\MultifunctionAdapter\'+
         AdapterList.Strings[l]+'\'+AdapterEntrys.Strings[l1]+'\0');
   end;
  AdapterEntrys.Free;
 end;
AdapterList.Free;
end;


procedure TForm1.ShowRessources(key:string);
var s:xBufType;
    Res:PPartialResourceList;
    x:integer;

begin
Res:=addr(s);
FillChar(s,sizeof(s),#0);
s:=ReadValueBuf(HKLM,key,'Configuration Data');
Memo1.Lines.Add(key);
if LastRead_CountBytes>0 then
for x:=1 to res.header.Count do
  begin
   case TResourceType(Res.Entrys[x-1].Typ) of
    tInterrupt: begin
                  Memo1.Lines.Add('Interrupt:');
                  Memo1.Lines.Add(' Level    '+IntToStr(res.Entrys[x-1].Level));
                  Memo1.Lines.Add(' Vector   '+IntToStr(res.Entrys[x-1].Vector));
                  Memo1.Lines.Add(' Affinity 0x'+IntToHex(res.Entrys[x-1].Affinity,6));
                  Memo1.Lines.Add('');
                 end;
    tPort      :  begin
                  Memo1.Lines.Add('Port:');
                  Memo1.Lines.Add(' Address 0x'+IntToHex(res.Entrys[x-1].Address,5));
                  Memo1.Lines.Add(' Length  '+IntToStr(res.Entrys[x-1].Length));
                  Memo1.Lines.Add('');
                 end;
    tDMA       : begin
                  Memo1.Lines.Add('DMA:');
                  Memo1.Lines.Add(' Channel '+IntToStr(res.Entrys[x-1].Channel));
                  Memo1.Lines.Add(' Port    0x'+IntToHex(res.Entrys[x-1].Port,5));
                  Memo1.Lines.Add('');
                 end;
   tDeviceSpecific: begin
                  Memo1.Lines.Add('Device specific data:');
                  Memo1.Lines.Add(' DataSize '+IntToStr(res.Entrys[x-1].DataSize));
                  Memo1.Lines.Add('');
                 end;
      else Memo1.Lines.Add('unknown entrytype '+IntToHex(res.Entrys[x-1].typ,7));
   end; //case
  end;  //for
Memo1.Lines.Add('---------------------------');
end;

procedure TForm1.StringGrid1DblClick(Sender: TObject);
var ARow,l,l0,RowCnt: Integer;
    s:string;

begin
 ARow:=StringGrid1.Row;
 if (ARow<257) and (ARow>0) then
   begin
    with ResView do
      begin
       for l:=0 to StringGrid1.RowCount do StringGrid1.Rows[l].Clear;
       for l:=0 to StringGrid2.RowCount do StringGrid2.Rows[l].Clear;
       for l:=0 to StringGrid3.RowCount do StringGrid3.Rows[l].Clear;
       StringGrid1.RowCount:=6;
       StringGrid2.RowCount:=6;
       StringGrid3.RowCount:=6;
       Memo1.Lines.Clear;
       Memo5.Lines.Clear;
      end;
    s:='';
    if IntList[ARow-1].Count>0 then
      begin
        for l0:=0 to IntList[ARow-1].Count-1 do
         begin
          s:=s+'used from device "'+
             DevList[IntList[ARow-1].List[l0]].Name+'" ';
          s:=s+'which allocates:'#10#13#10#13;
          ResView.Caption:=DevList[IntList[ARow-1].List[l0]].Name+
                           ' allocates:';
          for l:=0 to DevList[IntList[ARow-1].List[l0]].ResCount-1 do
           begin
            with DevList[IntList[ARow-1].List[l0]].ResList[l] do
            case TResourceType(Typ) of
              tPort: begin
                      RowCnt:=ResView.StringGrid1.RowCount;
                      ResView.StringGrid1.Cells[0,RowCnt-5]:='0x'+IntToHex(address,5);
                      ResView.StringGrid1.Cells[1,RowCnt-5]:=IntToStr(length);
                      ResView.StringGrid1.RowCount:=RowCnt+1;
                     end;
              tMemory: begin
                      ResView.Memo1.Lines.Add('Address:0x'+IntToHex(address,9)+
                         ' - 0x'+IntToHex(address+length,9));
                     end;
              tInterrupt: begin
                      RowCnt:=ResView.StringGrid2.RowCount;
                      ResView.StringGrid2.Cells[0,RowCnt-5]:='0x'+IntToHex(vector,2)+
                                                            ' / '+IntToStr(vector);
                      ResView.StringGrid2.Cells[1,RowCnt-5]:=IntToStr(level);
                      ResView.StringGrid2.Cells[2,RowCnt-5]:='0x'+IntToHex(affinity,2);
                      ResView.StringGrid2.RowCount:=RowCnt+1;
                     end;
               tDMA: begin
                      RowCnt:=ResView.StringGrid3.RowCount;
                      ResView.StringGrid3.Cells[0,RowCnt-5]:=IntToStr(channel);
                      ResView.StringGrid3.Cells[1,RowCnt-5]:='0x'+IntToHex(port,3);
                      ResView.StringGrid3.RowCount:=RowCnt+1;
                     end;
               tDeviceSpecific: begin
                      ResView.Memo5.Lines.Add('DataSize: '+IntToStr(DataSize));
                     end;
              end; //case
           end; //for
         end; //for
        with ResView do
          begin
            PortLbl.Caption:='Ports ('+IntToStr(StringGrid1.RowCount-6)+')';
            IntLbl.Caption:='Interrupts ('+IntToStr(StringGrid2.RowCount-6)+')';
            DMALbl.Caption:='DMA Channels ('+IntToStr(StringGrid3.RowCount-6)+')';
          end;
        if ARow-1<19 then
          s:='Reserved from Intel for "'+
             ReservedInterrupts[ARow-1]+'"' else
        if ARow-1<32 then
          s:='Reserved from Intel for internal or later use !';
        if ARow-1<32 then
           Application.MessageBox(PChar(s),PChar('Interrupt 0x'+IntToHex(ARow-1,2)
                               +'/'+IntToStr(ARow-1)),MB_OK) else
           ResView.ShowModal;
      end else
      begin
           Application.MessageBox(PChar('no details available ...'),
                                  PChar('Interrupt 0x'+IntToHex(ARow-1,2)
                                   +'/'+IntToStr(ARow-1)),MB_OK);
      end;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var ResMapList,ResMapEntrys,ValueList:TStringList;
    l,l1,l2,DevIndex:integer;

begin
DevIndex:=0;
ResMapList:=TStringList.Create;
ReadKeys(HKLM,'Hardware\Resourcemap', ResMapList);
for l:=0 to ResMapList.Count-1 do
 begin
  ResMapEntrys:=TStringList.Create;
  ReadKeys(HKLM,'Hardware\Resourcemap\'+ResMapList.Strings[l],ResMapEntrys);
  for l1:=0 to ResMapEntrys.Count-1 do
   begin
    ValueList:=TStringList.Create;
    ReadValues(HKLM,'Hardware\Resourcemap\'+ResMapList.Strings[l]+'\'+
             ResMapEntrys.Strings[l1],ValueList);
    for l2:=0 to ValueList.Count-1 do
      begin
       if Pos('.Translated',ValueList.Strings[l2])<>0 then
        begin
         DevList[DevIndex].Name:=ResMapEntrys.Strings[l1];
         GetResList('Hardware\Resourcemap\'+ResMapList.Strings[l]+'\'+
                     ResMapEntrys.Strings[l1],ValueList.Strings[l2],
                     DevIndex);
         inc(DevIndex);
         break;
        end;
      end;
    ValueList.Free;
   end;
  ResMapEntrys.Free;
 end;
ResMapList.Free;
Memo1.Lines.Add(IntToStr(DevIndex)+' devices detected ...');
end;

procedure TForm1.GetResList(key,value:string;DevIndex:integer);
var s:xBufType;
    l0,l1,ResIndex:integer;
    CurrentAdr:dword;
    Res:PPartialResourceList;
    pCount:^integer;

begin
CurrentAdr:=0;
FillChar(s,sizeof(s),#0);
s:=ReadValueBuf(HKLM,key,value);
pCount:=addr(s);
ResIndex:=0;
if LastRead_CountBytes>0 then
for l0:=1 to pCount^ do
  begin
   Res:=addr(s[4+CurrentAdr]);
//
   for l1:=0 to Res.header.Count-1 do
    begin
     DevList[DevIndex].ResList[ResIndex]:=Res.Entrys[l1];
     if TResourceType(Res.Entrys[l1].typ)=tInterrupt then
       begin
        IntList[Res.Entrys[l1].vector].List[
                IntList[Res.Entrys[l1].vector].count]:=DevIndex;
        inc(IntList[Res.Entrys[l1].vector].count);
       end;
     inc(ResIndex);
    end;
//
   CurrentAdr:=CurrentAdr+Res.header.Count*sizeof(TPartialResourceDescriptor)+
               sizeof(res.header) ;
  end;

DevList[DevIndex].ResCount:=ResIndex;
end;


procedure TForm1.Refresh1Click(Sender: TObject);
var l:integer;
begin
 Memo1.Lines.Add('Refresh ...');
 for l:=0 to 255 do IntList[l].Count:=0;
 Button3Click(Sender);
 Button1Click(Sender);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 GetInfos;
 ShowMessage(GetFileDescription+' - Build '+GetFileVersion+#13#10+GetCopyRight+
             #13#10#13#10+'This is Freeware !');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SaveList1Click(Sender: TObject);
var f:file;
    wb0,wb1,wb2:integer;

begin
 if SaveDialog1.Execute then
  begin
    Memo1.Lines.Add('writing list to '+SaveDialog1.FileName);
    AssignFile(f,SaveDialog1.FileName);
    Rewrite(f,1);
    Blockwrite(f,idt,sizeof(idt),wb0);
    Blockwrite(f,IntList,sizeof(IntList),wb1);
    Blockwrite(f,DevList,sizeof(DevList),wb2);
    CloseFile(f);
    if wb0+wb1+wb2<>sizeof(idt)+sizeof(DevList)+sizeof(IntList) then
      ShowMessage('Error writing List !');
  end;
end;

procedure TForm1.OpenList1Click(Sender: TObject);
var f:file;
    wb0,wb1,wb2:integer;

begin
 if OpenDialog1.Execute then
  begin
    Memo1.Lines.Add('loading list from '+OpenDialog1.FileName);
    AssignFile(f,OpenDialog1.FileName);
    Reset(f,1);
    Blockread(f,idt,sizeof(idt),wb0);
    Blockread(f,IntList,sizeof(IntList),wb1);
    Blockread(f,DevList,sizeof(DevList),wb2);
    CloseFile(f);
    if wb0+wb1+wb2<>sizeof(idt)+sizeof(DevList)+sizeof(IntList) then
      ShowMessage('Error reading List !');
    ListLoaded:=true;
    Button1Click(Sender);
    ListLoaded:=false;
  end;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
 Form2.ShowModal;
end;

end.
