// Unit mysystem
//
// bietet erweiterte Systemfunktionen
//
// written 1997-1998 by Guido Wischrop
//

unit mysystem;

interface

uses windows,sysutils,forms;

procedure SetFocusByName(wName:string;myHandle:THandle);
function  SetFocusByHandle(h:THandle;x:integer):boolean;
function  GetHandleByName(wName:string;myHandle:THandle):THandle;
procedure kp(i:integer);
procedure kd(i:integer);
procedure ku(i:integer);
function  WinErrorToString(error:integer):string;
procedure ShowWinError(msg:string);
function  EnablePrivilege(PrivName:string):boolean;
function  DisablePrivilege(PrivName:string):boolean;
function  SetTime(h,m,s:integer):boolean;
function  GetPentiumTimeStamp:int64;

const WM_TIMECHANGE=$1E;

const InternalVersion='00.02c';

implementation

procedure kd(i:integer);
begin
keybd_event(i,0,0,0);
sleep(20);
end;

procedure ku(i:integer);
begin
sleep(20);
keybd_event(i,0,KEYEVENTF_KEYUP,0);
end;

procedure kp(i:integer);
begin
keybd_event(i,0,0,0);
sleep(20);
keybd_event(i,0,KEYEVENTF_KEYUP,0);
sleep(20);
end;

procedure SetFocusByName(wName:string;myHandle:THandle);
var wN: array [0..255] of char;
    h:THandle;
    s:string;

begin
 h:=myHandle;
 while h>0 do
   begin
    h:= GetnextWindow(h, GW_HWNDNEXT);
    GetWindowText(h,wN,256);
    s:=StrPas(wN);
    if Pos(wName,s)<>0 then
      begin
       ShowWindow(h,SW_SHOWNORMAL);
       SetForegroundWindow(h);
       break;
      end;
   end;
end;

function SetFocusByHandle(h:THandle;x:integer):boolean;
var i:integer;
begin
 i:=0;
 SetForegroundWindow(h);
 if x=0 then ShowWindow(h,SW_SHOWNORMAL) else
             ShowWindow(h,SW_MAXIMIZE);
 Result:=(GetForeGroundWindow=h);
 if not Result then
   while (not Result) and (i<10) do
     begin
      inc(i);
      Result:=(GetForeGroundWindow=h);
      if not Result then sleep(300);
     end;
end;

function GetHandleByName(wName:string;myHandle:THandle):THandle;
var wN: array [0..255] of char;
    h:THandle;
    s:string;

begin
 h:=myHandle;
 Result:=0;
 while h>0 do
   begin
    h:= GetnextWindow(h, GW_HWNDNEXT);
    GetWindowText(h,wN,256);
    s:=StrPas(wN);
    if Pos(wName,s)<>0 then
      begin
       Result:=h;
      end;
   end;
end;

function WinErrorToString(error:integer):string;
var buf : array [0..$FFFF] of char;
begin
 FillChar(buf, SizeOf(buf), #0);
 FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, error,
               LANG_SYSTEM_DEFAULT, @buf, sizeof(buf), nil);
 Result:=buf;
 while Pos(#13#10,Result)>0 do Delete(Result,Pos(#13#10,Result),2);
end;

procedure ShowWinError(msg:string);
begin
 Application.MessageBox(PChar(WinErrorToString(GetLastError)),
                        PChar(msg),MB_ICONSTOP + MB_OK);
end;

function EnablePrivilege(PrivName:string):boolean;
var mTokenPriv,mTokenPrivPrev:TTokenPrivileges;
    mToken:THandle;
    BufLen:DWord;
begin
 Result:=false;
 OpenProcessToken(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES+
                  TOKEN_QUERY,mToken);
 mTokenPriv.PrivilegeCount:=1;
 if LookupPrivilegeValue(Nil,PChar(PrivName),
                          mTokenPriv.Privileges[0].LUID )then
   begin
    mTokenPriv.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
    BufLen:=0;
    Result:=AdjustTokenPrivileges(mToken,False,mTokenPriv,
                                  sizeOf(mTokenPrivPrev),mTokenPrivPrev,
                                  BufLen);
  end;
  CloseHandle(mToken);
end;

function DisablePrivilege(PrivName:string):boolean;
var mTokenPriv,mTokenPrivPrev:TTokenPrivileges;
    mToken:THandle;
    BufLen:DWord;
begin
 Result:=false;
 OpenProcessToken(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES+
                  TOKEN_QUERY,mToken);
 mTokenPriv.PrivilegeCount:=1;
 if LookupPrivilegeValue(Nil,PChar(PrivName),
                          mTokenPriv.Privileges[0].LUID ) then
   begin
    mTokenPriv.Privileges[0].Attributes:=0;
    BufLen:=0;
    Result:=AdjustTokenPrivileges(mToken,False,mTokenPriv,
                                  sizeOf(mTokenPrivPrev),mTokenPrivPrev,
                                  BufLen);
   end;
  CloseHandle(mToken);
end;


function SetTime(h,m,s:integer):boolean;
var mTime:TSystemTime;
begin
Result:=false;
if EnablePrivilege('SeSystemtimePrivilege') then
 begin
  GetLocalTime(mTime);
  mTime.wHour:=h;
  mTime.wMinute:=m;
  mTime.wSecond:=s;
  SetLocalTime(mTime);
  DisablePrivilege('SeSystemtimePrivilege');
  PostMessage(HWND_BROADCAST,WM_TIMECHANGE,0,0);
  end;
end;

function  GetPentiumTimeStamp:int64;
asm
// rdtsc - Read Time Stamp Counter
  DB 0FH
  DB 031H
end;


end.
