// Unit brun_setup1
//
// das Setup-Formular fuer Brunelco Control Center
//
// written 1998 by Guido Wischrop
//

unit brun_setup1;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Spin, Inifiles;

type
  TSetupDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;
    Combo_BaseAdress: TComboBox;
    Label1: TLabel;
    Spin_RefreshCnt: TSpinEdit;
    Label2: TLabel;
    RadioGroup_ClockInit: TRadioGroup;
    Check_ClearMemory: TCheckBox;
    RadioGroup_DriverLoad: TRadioGroup;
    Check_UseFastMethod: TCheckBox;
    Label3: TLabel;
    Spin_SoftDelay: TSpinEdit;
    Check_AntiBounce: TCheckBox;
    procedure Check_ClearMemoryClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure RadioGroup_ClockInitClick(Sender: TObject);
    procedure Check_AntiBounceClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SetupDlg: TSetupDlg;

implementation

{$R *.DFM}

procedure TSetupDlg.Check_ClearMemoryClick(Sender: TObject);
begin
// if Check_ClearMemory.Checked then RadioGroup_ClockInit.ItemIndex:=3;
end;

procedure TSetupDlg.FormActivate(Sender: TObject);
var mIni:TIniFile;
begin
mIni:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'brunelco.ini');
with mIni do
  begin
// Card Init
    Combo_BaseAdress.ItemIndex:=ReadInteger('Init','BaseAdr',2);
    Spin_RefreshCnt.Value:=ReadInteger('Init','Refresh',10);
    RadioGroup_ClockInit.ItemIndex:=ReadInteger('Init','ClockInit',3);
    Check_ClearMemory.Checked:=ReadBool('Init','ClearMemory',false);
// Driver Init
    RadioGroup_DriverLoad.ItemIndex:=ReadInteger('Init','DriverLoad',0);
    Check_UseFastMethod.Checked:=ReadBool('Init','UseFastMethod',false);
// Misc
    Spin_SoftDelay.Value:=ReadInteger('Misc','SoftDelay',10);
    Check_AntiBounce.Checked:=ReadBool('Misc','EnableAntiBounce',false);
    Check_AntiBounceClick(sender);
  end;
mIni.Free;
end;

procedure TSetupDlg.OKBtnClick(Sender: TObject);
var mIni:TIniFile;
begin
mIni:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'brunelco.ini');
with mIni do
  begin
// Card Init
    WriteInteger('Init','BaseAdr',Combo_BaseAdress.ItemIndex);
    WriteInteger('Init','Refresh',Spin_RefreshCnt.Value);
    WriteInteger('Init','ClockInit',RadioGroup_ClockInit.ItemIndex);
    WriteBool('Init','ClearMemory',Check_ClearMemory.Checked);
// Driver Init
    WriteInteger('Init','DriverLoad',RadioGroup_DriverLoad.ItemIndex);
    WriteBool('Init','UseFastMethod',Check_UseFastMethod.Checked);
// Misc
    WriteInteger('Misc','SoftDelay',Spin_SoftDelay.Value);
    WriteBool('Misc','EnableAntiBounce',Check_AntiBounce.Checked);
  end;
mIni.Free;
end;

procedure TSetupDlg.RadioGroup_ClockInitClick(Sender: TObject);
begin
// if RadioGroup_ClockInit.ItemIndex=99 then Check_ClearMemory.Checked:=false;
end;

procedure TSetupDlg.Check_AntiBounceClick(Sender: TObject);
begin
 if Check_AntiBounce.Checked then
   begin
    Label3.Enabled:=true;
    Spin_SoftDelay.Enabled:=true;
   end else
   begin
    Label3.Enabled:=false;
    Spin_SoftDelay.Enabled:=false;
   end;
end;

end.

