// Unit brun_u1
//
// Haupt-Formular fuer Brunelco Control Center
//
// written 1998 by Guido Wischrop
//


unit brun_u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, IniFiles;

type TMyTimeStamp = record
        h,m,s,hs,ts:integer;
      end;
type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Memo1: TMemo;
    LB_FirstTrigger: TListBox;
    Label1: TLabel;
    LB_SecondTrigger: TListBox;
    LB_Diff: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Setup1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Info1: TMenuItem;
    About1: TMenuItem;
    Action1: TMenuItem;
    ResetCard1: TMenuItem;
    PCClockCardClock1: TMenuItem;
    CardClockPCClock1: TMenuItem;
    N2: TMenuItem;
    Autostart1: TMenuItem;
    Autostop1: TMenuItem;
    RestartClock1: TMenuItem;
    SetClockto0000001: TMenuItem;
    StopClock1: TMenuItem;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure Exit1Click(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure ResetCard1Click(Sender: TObject);
    procedure RestartClock1Click(Sender: TObject);
    procedure PCClockCardClock1Click(Sender: TObject);
    procedure CardClockPCClock1Click(Sender: TObject);
    procedure Autostart1Click(Sender: TObject);
    procedure SetClockto0000001Click(Sender: TObject);
    procedure Autostop1Click(Sender: TObject);
    procedure StopClock1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    DriverControlCode,ClockInit,BaseAddress,SoftDelay:integer;
    lastTime: array [0..7] of byte;
    trigger: array [0..15] of boolean;
    TimeStamps: array [0..15] of TMyTimeStamp;
    myHandle:THandle;
    UseFastMethod,ClearMemory,AntiBounce:boolean;
    function DoFunction(code:byte):byte;
    function SetBaseAddress:boolean;
    function GetDriverVersion:string;
    procedure GetLastTime;
    procedure SetAntiBounce(x:integer);
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

const DriverControl_StartStop = 0;
      DriverControl_Start     = 1;
      DriverControl_Stop      = 2;
      DriverControl_None      = 3;
      BaseAddressArray: array [0..5] of integer=(
                                             $300,
                                             $310,
                                             $320,
                                             $330,
                                             $340,
                                             $350);


      IOCTL_Brunelco_GetLastTime    = $222004;
      IOCTL_Brunelco_SetBaseAddress = $222008;
      IOCTL_Brunelco_UniAccess      = $222400;
      IOCTL_Brunelco_GetVersion     = $222404;

implementation

uses brun_setup1,myvers,driver,mysystem;

{$R *.DFM}

function TForm1.DoFunction(code:byte):byte;
var inBuffer: packed record
          BaseAdr:integer;
          FunctionCode:integer;
         end;
    outBuffer: array [0..3] of byte;
    bg:cardinal;

begin
 inBuffer.BaseAdr:=BaseAddress;
 inBuffer.FunctionCode:=code;
 if DeviceIoControl(myHandle,IOCTL_Brunelco_UniAccess,@inBuffer,
                    sizeof(inBuffer),@outBuffer,
                    sizeof(outBuffer),bg,NIL) then
    Result:=outBuffer[0] else
    Result:=128;
end;

function TForm1.SetBaseAddress:boolean;
var inBuffer: packed record
          BaseAdr:integer;
          FunctionCode:integer;
         end;
    outBuffer: array [0..3] of byte;
    bg:cardinal;

begin
 inBuffer.BaseAdr:=BaseAddress;
 inBuffer.FunctionCode:=0;
 Result:=DeviceIoControl(myHandle,IOCTL_Brunelco_SetBaseAddress,@inBuffer,
                    sizeof(inBuffer),@outBuffer,sizeof(outBuffer),bg,NIL);
end;


procedure TForm1.GetLastTime;
var inBuffer: packed record
          BaseAdr:integer;
          FunctionCode:integer;
         end;
    bg:cardinal;

begin
 inBuffer.BaseAdr:=BaseAddress;
 inBuffer.FunctionCode:=00;
 if UseFastMethod then
   begin
    ReadFile(myHandle,lastTime,sizeof(lastTime),bg,NIL);
   end else
   begin
    lastTime[0]:=DoFunction(1);
    lastTime[1]:=DoFunction(2);
    lastTime[2]:=DoFunction(3);
    lastTime[3]:=DoFunction(4);
    lastTime[4]:=DoFunction(5);
    lastTime[5]:=DoFunction(6);
   end;
end;

function TForm1.GetDriverVersion:string;
var inBuffer: packed record
          BaseAdr:integer;
          FunctionCode:integer;
         end;
    bg:cardinal;
    outBuffer: array [0..15] of char;

begin
 FillChar(outBuffer,16,#0);
 inBuffer.BaseAdr:=BaseAddress;
 inBuffer.FunctionCode:=00;
 if DeviceIoControl(myHandle,IOCTL_Brunelco_GetVersion,@inBuffer,
                 sizeof(inBuffer),@outBuffer,sizeof(outBuffer),bg,NIL) then
    Result:=outBuffer else Result:='cant get version';

end;

procedure TForm1.SetAntiBounce(x:integer);
begin
 if DoFunction(29)=100 then DoFunction(x);
end;

procedure TForm1.FormCreate(Sender: TObject);
var sa:PSecurityAttributes;
    i:integer;
    mIni:TIniFile;
    Action: TCloseAction;

begin
Timer1.Enabled:=false;
if ParamCount>0 then
  begin
   if Pos('nomsg',ParamStr(2))>0 then ShowErrorBoxes:=false;
   if (Pos('setup',ParamStr(1))>0) or (not FileExists(ExtractFilePath(
       ParamStr(0))+'brunelco.ini')) then
    begin
     Application.CreateForm(TSetupDlg, SetupDlg);
     Setup1Click(Sender);
     SetupDlg.Free;
    end else
   if  Pos('instdrv',ParamStr(1))>0 then
     begin
      InstallDriver('brunelco',ExtractFilePath(ParamStr(0))+'brun.sys');
      StartDriver('brunelco');
      halt(0);
     end else
   if  Pos('remdrv',ParamStr(1))>0 then
     begin
      StopDriver('brunelco');
      RemoveDriver('brunelco');
      halt(0);
     end;
  end;
GetInfos;
mIni:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'brunelco.ini');
with mIni do
  begin
// Card Init
    BaseAddress:=BaseAddressArray[ReadInteger('Init','BaseAdr',2)];
    Timer1.Interval:=ReadInteger('Init','Refresh',10)*100;
    ClockInit:=ReadInteger('Init','ClockInit',3);
    ClearMemory:=ReadBool('Init','ClearMemory',false);
// Driver Init
    DriverControlCode:=ReadInteger('Init','DriverLoad',0);
    UseFastMethod:=ReadBool('Init','UseFastMethod',false);
// Misc
    SoftDelay:=ReadInteger('Misc','SoftDelay',10);
    AntiBounce:=ReadBool('Misc','EnableAntiBounce',false);
  end;
mIni.Free;

// Driver Init
case DriverControlCode of
   DriverControl_StartStop,
   DriverControl_Start
                          : begin
                             InstallDriver('brunelco',
                                           ExtractFilePath(ParamStr(0))+
                                           'brun.sys');
                             StartDriver('brunelco');
                            end;
   end;

//create global handle
sa:=new(PSecurityAttributes);
sa.nLength:=sizeof(TSecurityAttributes);
sa.lpSecurityDescriptor:=NIL;
sa.bInheritHandle:=false;
myHandle:=CreateFile('\\.\Brunelco',GENERIC_READ,FILE_SHARE_READ,
                     sa,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
if myHandle=INVALID_HANDLE_VALUE then
  begin
    ShowMessage('Cant get handle from driver !');
  end;

//get version infos
i:=DoFunction(26);
if i=128 then
  begin
    if Application.MessageBox('Card returns invalid value (128) !'#10#13#13+
                              'Stop program is HIGHLY recommended !',
                              'Stop program ?',
                              MB_YESNO+MB_ICONSTOP+MB_APPLMODAL)=idyes then
       begin
         FormClose(Sender,Action);
         halt;
       end;
  end;
StatusBar1.Panels[1].Text:='Card Version '+IntToStr(i div 10)+'.'+
                           IntToStr(i mod 10);
StatusBar1.Panels[2].Text:=GetFileDescription;
StatusBar1.Panels[3].Text:='Build '+GetFileVersion;
StatusBar1.Panels[4].Text:='Driver Version '+GetDriverVersion;


//clear memory
if ClearMemory then ResetCard1Click(Sender);

//Clock Init
case ClockInit of
    0: begin
        PCClockCardClock1Click(Sender);
       end;
    1: begin
        CardClockPCClock1Click(Sender);
       end;
    2: begin
        SetClockto0000001Click(Sender);
       end;
  end; //case

// init anti-bounce
if AntiBounce then SetAntiBounce(SoftDelay) else SetAntiBounce(0);

// set GlobalBaseAddress
SetBaseAddress;

//init trigger listboxes
for i:=0 to 15 do
  begin
   LB_FirstTrigger.Items.Add('0');
   LB_SecondTrigger.Items.Add('0');
   LB_Diff.Items.Add('0');
   trigger[i]:=false;
  end;
Timer1.Enabled:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseHandle(myHandle);
case DriverControlCode of
   DriverControl_StartStop,
   DriverControl_Stop
                          : begin
                             StopDriver('brunelco');
                             RemoveDriver('brunelco');
                            end;
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var mTime:TDateTime;
    ss,ss0:string;
    df,df0,df1:double;
    i:integer;


begin
 Timer1.Enabled:=false;
 i:=DoFunction(15);
 if i=100 then
 repeat
   GetLastTime;
   try
    mTime:=StrToTime(IntToStr(lastTime[1])+':'+IntToStr(lastTime[2])+':'+
                     IntToStr(lastTime[3]));
    ss:=FormatDateTime('hh:nn:ss',mTime);
   except
    ss:=IntToStr(lastTime[1])+':'+IntToStr(lastTime[2])+':'+
        IntToStr(lastTime[3]);
   end;
   if lastTime[0]=20 then StatusBar1.Panels[0].Text:=ss else
     begin
      if lastTime[4]<10 then ss:=ss+'0'+IntToStr(lastTime[4]) else
         ss:=ss+IntToStr(lastTime[4]);
      if lastTime[5]<10 then ss:=ss+'0'+IntToStr(lastTime[5]) else
         ss:=ss+IntToStr(lastTime[5]);
      Memo1.Lines.Add('Trigger '+IntToStr(lastTime[0])+' - '+ss);
      if lastTime[0]<17 then
        begin
         if trigger[lastTime[0]-1] then
           begin
            df0:=TimeStamps[lastTime[0]-1].h*3600+TimeStamps[lastTime[0]-1].m*60+
                TimeStamps[lastTime[0]-1].s;
            df:=TimeStamps[lastTime[0]-1].hs*100+
                 TimeStamps[lastTime[0]-1].ts;
            if df>0.0 then df0:=df0+df/10000;
            df1:=lastTime[1]*3600+lastTime[2]*60+lastTime[3];
            df:=lastTime[4]*100+lastTime[5];
            if df>0.0 then df1:=df1+df/10000;
            df:=df1-df0;
            Str(df:3:4,ss0);
            LB_SecondTrigger.Items.Strings[lastTime[0]-1]:=ss;
            LB_Diff.Items.Strings[lastTime[0]-1]:=ss0;
            trigger[lastTime[0]-1]:=false;
           end else
           begin
            TimeStamps[lastTime[0]-1].h:=lastTime[1];
            TimeStamps[lastTime[0]-1].m:=lastTime[2];
            TimeStamps[lastTime[0]-1].s:=lastTime[3];
            TimeStamps[lastTime[0]-1].hs:=lastTime[4];
            TimeStamps[lastTime[0]-1].ts:=lastTime[5];
            LB_FirstTrigger.Items.Strings[lastTime[0]-1]:=ss;
            LB_SecondTrigger.Items.Strings[lastTime[0]-1]:='0';
            LB_Diff.Items.Strings[lastTime[0]-1]:='0';
            trigger[lastTime[0]-1]:=true;
           end;
        end;
     end;
   i:=DoFunction(14);
 until (i<>100) and (i<>128);;
 Application.ProcessMessages;
 Timer1.Enabled:=true;
end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
 resize:=false;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
 SetupDlg.ShowModal;
end;

procedure TForm1.ResetCard1Click(Sender: TObject);
begin
 Timer1.Enabled:=false;
 if DoFunction(24)=100 then
  begin
   DoFunction(219);
   sleep(2000);
  end;
 Timer1.Enabled:=true;
end;

procedure TForm1.RestartClock1Click(Sender: TObject);
begin
  if DoFunction(12)<>100 then
     ShowMessage('Error starting clock !');
end;

procedure TForm1.PCClockCardClock1Click(Sender: TObject);
var mTime:TDateTime;
    res:boolean;

begin
 Timer1.Enabled:=false;
 RestartClock1Click(Sender);
 mTime:=time;
 res:=true;
// hour
 if DoFunction(8)=100 then
    DoFunction(StrToInt(FormatDateTime('hh',mTime))) else res:=false;
// minutes
 if res and (DoFunction(9)=100) then
    DoFunction(StrToInt(FormatDateTime('nn',mTime))) else res:=false;
// seconds
 if res and (DoFunction(10)=100) then
    DoFunction(StrToInt(FormatDateTime('ss',mTime))) else res:=false;
 if not res then
     ShowMessage('Error PC Clock -> Card Clock !');
 Timer1.Enabled:=true;
end;

procedure TForm1.CardClockPCClock1Click(Sender: TObject);

begin
Timer1.Enabled:=false;
if DoFunction(15)=100 then
  begin
   SetTime(LastTime[1],LastTime[2],LastTime[3]);
  end;
Timer1.Enabled:=true;
end;

procedure TForm1.Autostart1Click(Sender: TObject);
begin
Timer1.Enabled:=false;
 if Autostart1.Checked then
   begin
    Autostart1.Checked:=false;
    DoFunction(17);
   end else
   begin
    Autostart1.Checked:=true;
    DoFunction(16);
   end;
Timer1.Enabled:=true;
end;

procedure TForm1.SetClockto0000001Click(Sender: TObject);
begin
Timer1.Enabled:=false;
 DoFunction(13);
 if DoFunction(12)<>100 then
     ShowMessage('Error starting clock !');
Timer1.Enabled:=true;
end;

procedure TForm1.Autostop1Click(Sender: TObject);
begin
Timer1.Enabled:=false;
 if Autostop1.Checked then
   begin
    Autostop1.Checked:=false;
    DoFunction(19);
   end else
   begin
    Autostop1.Checked:=true;
    DoFunction(18);
   end;
Timer1.Enabled:=true;
end;

procedure TForm1.StopClock1Click(Sender: TObject);
begin
Timer1.Enabled:=false;
 if DoFunction(11)<>100 then
   ShowMessage('Error stoping clock !');
Timer1.Enabled:=true;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 ShowMessage(GetFileDescription+' Build '+GetFileVersion+#13#10+GetCopyRight+
             #13#10#13#10+'Driver brun.sys Version '+GetDriverVersion+#13#10+
             'written 1998 by Guido Wischrop');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 Memo1.Lines.Clear;
end;

end.
