//
// Unit myvers
//
// implementiert Funktionen, um Versionsinformationen
// aus einem EXE File auszulesen
//
// written 1998 by Guido Wischrop
//

unit myvers;

interface

uses windows,sysutils,forms;

type xVArray=array [0..7] of string;

function GetCopyRight:string;
function GetFileDescription:string;
function GetFileVersion:string;
function GetProductVersion:string;
procedure GetInfos;

implementation


const vArray:xVArray=('CompanyName', 'FileDescription', 'FileVersion', 'InternalName',
     'LegalCopyright', 'OriginalFilename', 'ProductName', 'ProductVersion');

var fInfos:xVArray;

procedure GetInfos;
var size,i:integer;
    dummy,ts:cardinal;
    buffer:pchar;
    tp,tt:pchar;
    CharSet:string;

begin
size:=GetFileVersionInfoSize(Pchar(Application.Exename), dummy);
if size>0 then
  begin
    buffer := StrAlloc(size+1);
    GetFileVersionInfo(Pchar(Application.Exename), 0, size, buffer);
    VerQueryValue(buffer, '\VarFileInfo\Translation', Pointer(tp), ts);
    if ts>=4 then
      begin
        StrLCopy(@i, tp, 2);
        CharSet:=IntToHex(i, 4);
        StrLCopy(@i, tp+2, 2);
        CharSet:=CharSet+IntToHex(i, 4);
        for i:=0 to 7 do
          begin
            if VerQueryValue(buffer, pchar('\StringFileInfo\'+CharSet+'\'+
                         vArray[i]), pointer(tp), ts) then
              begin
               tt:=StrAlloc(ts+1);
               StrLCopy(tt, tp, ts);
               fInfos[i]:=StrPas(tt);
               StrDispose(tt);
              end else fInfos[i]:='<not available>';
          end;

      end;
    StrDispose(Buffer);
  end else
  begin
  end;
end;

function GetCopyRight:string;
begin
Result:=fInfos[4];
end;

function GetFileDescription:string;
begin
Result:=fInfos[1];
end;

function GetFileVersion:string;
begin
Result:=fInfos[2];
end;

function GetProductVersion:string;
begin
Result:=fInfos[7];
end;

begin
//GetInfos;
end.
